<?php

/**
 * @file
 * Functions for the batch process to migrate SPIP to Drupal.
 */

/**
 * Batch operations. Import SPIP sections as taxonomy terms.
 *
 * TODO: section logo (using taxonomy_image), texte
 */
function _spip2drupal_import_sections(&$context) {
  $link = spip_db_connect();

  // If it is the first time, initialize $context.
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_rubrique) FROM spip_rubriques WHERE statut='publie'";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['sections'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }

  // Get the next slice of items to import.
  $STEP = 20;
  $total = $context['sandbox']['total'];
  $current = $context['sandbox']['current'];

  // All sections will be cached. We need this to set section parents properly in a second step.
  $sections = array();
  
  // Import stuff.
  $vid = variable_get('spip2drupal_vocabulary_sections', NULL);
  $query = "SELECT id_rubrique FROM spip_rubriques WHERE statut='publie' LIMIT $current, $STEP";
  $rsc = mysql_query($query, $link);
  while ($row = mysql_fetch_object($rsc)) {
    $data = _spip2drupal_fetch('id_rubrique', $row->id_rubrique);
    if ($data === FALSE) {
      $context['sandbox']['current']++;
      continue;
    }
    $term = array(
      'vid' => $vid,
      'name' => $data->titre,
      'description' => $data->descriptif
    );
    taxonomy_save_term($term);

    // Store the mapping.
    $record = array('id_rubrique' => $data->id_rubrique, 'tid' => $term['tid']);
    drupal_write_record('spip_sections', $record);
    $sections[$data->id_rubrique] = array('data' => $data, 'term' => $term);

    // Update $context and set messages.
    $context['results']['sections']++;
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    $context['message'] = "Importing keyword $current of $total.";
    _spip2drupal_watchdog('Section %section imported as taxonomy term @tid.', array('%section' => $term['name'], '@tid' => $term['tid']), l('edit taxonomy term', 'admin/content/taxonomy/edit/term/'.$term['tid']));
  }
  
  // Set parents.
  foreach ($sections as $section) {
    $data = $section['data'];
    if ($data->id_parent != '0') {
      $term = $section['term'];
      $parent = $sections[$data->id_parent]['term'];
      $term['parent'] = $parent['tid'];
      taxonomy_save_term($term);
      _spip2drupal_watchdog('Setting @parent as parent for term @tid.', array('@tid' => $term['tid'], '@parent' => $term['parent']), l('edit taxonomy term', 'admin/content/taxonomy/edit/term/'.$term['tid']));
    }
  }

  // Update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Batch operations. Import SPIP keyword groups as vocabularies.
 *
 * TODO: texte, unseul?
 */
function _spip2drupal_import_keyword_groups(&$context) {
  $link = spip_db_connect();

  // If it is the first time, initialize $context.
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_groupe) FROM spip_groupes_mots";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['keyword groups'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }

  // Get the next slice of items to import.
  $STEP = 20;
  $total = $context['sandbox']['total'];
  $current = $context['sandbox']['current'];
  $query = "SELECT id_groupe FROM spip_groupes_mots LIMIT $current, $STEP";
  $rsc = mysql_query($query, $link);

  // Import stuff.
  while ($row = mysql_fetch_object($rsc)) {
    $data = _spip2drupal_fetch('id_groupe', $row->id_groupe);
    if ($data === FALSE) {
      $context['sandbox']['current']++;
      continue;
    }
    if ($data->articles == 'oui') {
      $nodes['story'] = 1;
    }
    $vocab = array(
      'nodes' => $nodes,
      'name' => $data->titre,
      'description' => $data->descriptif,
      'relations' => 1,
      'hierarchy' => 1,
      'multiple' => 0,
      'required' => ($data->obligatoire=='non')?0:1,
      'tags' => 0,
    );
    taxonomy_save_vocabulary($vocab);

    // Store the mapping.
    $record = array('vid' => $vocab['vid'], 'id_groupe' => $row->id_groupe);
    drupal_write_record('spip_keywords_groups', $record);

    // Update $context and set messages.
    $context['results']['keyword groups']++;
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    $context['message'] = "Importing keyword group $current of $total.";
    _spip2drupal_watchdog('Keyword group %group imported as vocabulary @vid.', array('%group' => $vocab['name'], '@vid' => $vocab['vid']), l('edit vocabulary', 'admin/content/taxonomy/edit/vocabulary/'.$vocab['vid']));
  }

  // update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Batch operations. Import SPIP keywords as taxonomy terms.
 *
 * TODO: texte, unseul?
 */
function _spip2drupal_import_keywords(&$context) {
  $link = spip_db_connect();

  // If it is the first time, initialize $context.
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_mot) FROM spip_mots";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['keywords'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }

  $STEP = 20;
  $total = $context['sandbox']['total'];
  $current = $context['sandbox']['current'];

  // Cache mapping values for current batch iteration.
  $vocabularies = array();
  // Load all vocabularies now as they are a few.
  $rsc = db_query("SELECT * from {spip_keywords_groups}");
  while ($row = db_fetch_object($rsc)) {
    $vocabularies[$row->id_groupe] = $row->vid;
  }

  // Import stuff.
  $query = "SELECT id_mot FROM spip_mots LIMIT $current, $STEP";
  $rsc = mysql_query($query, $link);
  while ($row = mysql_fetch_object($rsc)) {
    $data = _spip2drupal_fetch('id_mot', $row->id_mot);
    if ($data === FALSE) {
      $context['sandbox']['current']++;
      continue;
    }
    $term = array(
      'vid' => $vocabularies[$data->id_groupe],
      'name' => $data->titre,
      'description' => $data->descriptif
    );
    taxonomy_save_term($term);
    
    // Store the mapping.
    $record = array('id_mot' => $row->id_mot, 'tid' => $term['tid']);
    drupal_write_record('spip_keywords', $record);

    // Update $context and set messages.
    $context['results']['keywords']++;
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    $context['message'] = "Importing keyword $current of $total.";
    _spip2drupal_watchdog('Keyword %keyword imported as taxonomy term @tid.', array('%keyword' => $term['name'], '@tid' => $term['tid']), l('edit taxonomy term', 'admin/content/taxonomy/edit/term/'.$term['tid']));
  }

  // update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Batch operation. Import SPIP users as drupal users.
 *
 * TODO: SPIP database fields: bio, nom_site, url_site, pgp, htpass, imessage, messagerie,alea_actuel, alea_futur, prefs, source, lang, extra, low_sec, idx
 */
function _spip2drupal_import_users(&$context) {
  $link = spip_db_connect();

  // If it is the first time, initialize $context.
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_auteur) FROM spip_auteurs";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['users'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }
  // Get the next slice of items to import.
  $STEP = 20;
  $total = $context['sandbox']['total'];
  $current = $context['sandbox']['current'];
  $query = "SELECT id_auteur, login FROM spip_auteurs LIMIT $current, $STEP";
  $rsc = mysql_query($query, $link);

  // Import stuff.
  $roles = array(
    '0minirezo' => variable_get('spip2drupal_roles_admin', NULL),
    '1comite' => variable_get('spip2drupal_roles_editor', NULL)
  );
  while ($row = mysql_fetch_object($rsc)) {
    $uid = _spip2drupal_user_exist($row->login);
    if ($uid === FALSE) {
      $data = _spip2drupal_fetch('id_auteur', $row->id_auteur);
      if ($data === FALSE) {
        $context['sandbox']['current']++;
        continue;
      }
      // Prepare the user to add.
      $account = array(
        'name' => $data->login,
        'mail' => $data->email,
        'created' => $data->maj,
        'access' => $data->en_ligne,
        'login' => $data->maj,
        'status' => ($data->statut == '5poubelle')?0:1,
        'roles' => isset($roles[$data->statut])?array($roles[$data->statut]):array()
      );
      // Save the user.
      $account = user_save(NULL, $account);
      $uid = $account->uid;
    }

    // Store the mapping.
    $record = array('id_auteur' => $row->id_auteur, 'uid' => $uid);
    drupal_write_record('spip_users', $record);

    // Update $context and set messages.
    $context['results']['users']++;
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    $context['message'] = "Importing user $current of $total.";
    _spip2drupal_watchdog('Imported user %auteur with uid %uid.', array('%auteur' => $row->login, '%uid' => $user->uid), l('edit user', 'user/'.$user->uid.'/edit'));
  }

  // update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Batch operation. Import SPIP articles as story nodes.
 * 
 * TODO: "surtitre";"soustitre";"descriptif";"ps";"id_secteur";     "maj";"export";"date_redac";"visites";"referers";"popularite";"accepter_forum";"auteur_modif";"extra";   "lang";"langue_choisie";"id_trad";"nom_site";"url_site";"id_version";"idx";"url_propre"
 *
 */
function _spip2drupal_import_articles(&$context) {
  $link = spip_db_connect();
  // if it is the first time, initialize the sandbox
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_article) FROM spip_articles";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['articles'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $STEP = 20;
  
  // Cache mapping values for current batch iteration.
  $auteurs = array();
  $sections = array();
  $keywords = array();
  // Load all sections now as they are a few.
  $rsc = db_query("SELECT * from {spip_sections}");
  while ($row = db_fetch_object($rsc)) {
    $sections[$row->id_rubrique] = $row->tid;
  }

  // values for below calls to preg_replace().
  $file_pattern = '/IMG(\/\w+)?\/(.*)\//';
  $file_replacement = '/'.file_directory_path().'/$2';
  
  // Import stuff.
  $query = "SELECT id_article FROM spip_articles LIMIT $current,$STEP";
  $rsc = mysql_query($query, $link);
  while ($row = mysql_fetch_object($rsc)) {
    $data = _spip2drupal_fetch('id_article', $row->id_article);
    if ($data === FALSE) {
      $context['sandbox']['current']++;
      continue;
    }
    if (!isset($auteurs[$data->id_auteur])) {
      $query = "SELECT uid FROM {spip_users} WHERE id_auteur = '".$data->id_auteur."' LIMIT 1";
      $auteurs[$data->id_auteur] = db_result(db_query($query));
    }
    $uid = $auteurs[$data->id_auteur];
    $files  = _spip2drupal_import_article_documents($data->id_article, $uid);
    $node = (object)array(
      'uid'     => $uid,
      'type'    => 'story',
      'title'   => $data->titre,
      'teaser'  => $data->introduction,
      'body'    => preg_replace($file_pattern, $file_replacement, $data->texte),
      'created' => $data->date,
      'changed' => $data->date_modif,
      'comment' => 1, // (1 = no further comments)
      'format'  => 2, // Full HTML
      'files'   => $files,
      'language' => $data->lang,
    );

    // calculate the article status
    switch ($data->statut) {
       // in the trash
      case 'poubelle':
        $node->status = 0;
        break;
      // published
      case 'publie':
        $node->status = 1;
        break;
      // draft (en cours de redaction)
      case 'prepa':
        $node->status = 0;
        break;
      // proposed to publish
      case 'prop': 
        $node->status = 0;
        break;        
      // refused
      case 'refuse':
        $node->status = 0;
        break;
    }
    $node->uid = $uid;

    // Save the node.
    node_save($node);
    if ($node->nid) {
      $record = array('id_article' => $data->id_article, 'nid' => $node->nid);
      drupal_write_record('spip_articles', $record);
    }

    // Taxonomy term for section.
    $term = $sections[$data->id_rubrique];
    taxonomy_node_save($node, array($term));

    // Taxonomy terms for keywords.
    $query = "SELECT id_mot FROM spip_mots_articles WHERE id_article = ".$data->id_article;
    $rs2 = mysql_query($query, $link) or form_set_error('', "Error en $query.");
    while ($row2 = mysql_fetch_object($rs2)) {
      if (!isset($sections[$row2->id_mot])) {
        $query = "SELECT tid FROM {spip_keywords} WHERE id_mot=%d LIMIT 1";
        $sections[$row2->id_mot] = db_result(db_query($query, $row2->id_mot));
      }
      $term = $sections[$row2->id_mot];
      taxonomy_node_save($node, array($term));
    }

    // update the sandbox
    $context['results']['articles']++;
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    $context['message'] = "Importing article $current of $total.";
    _spip2drupal_watchdog('Article @id imported as node @nid.', array('@id' => $data->id_article, '@nid' =>$node->nid), l('edit node', 'node/'.$node->nid.'/edit'));
  }

  // update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Helper function for _spip2drupal_import_articles
 *
 */
function _spip2drupal_import_article_documents($id_article, $uid) {
  $link = spip_db_connect();
  $spip_path = variable_get('spip2drupal_spip_path', NULL);
  $files_path = file_directory_path();
  $files = array();

  if ((float)variable_get('spip_version', NULL) < 2) {
    $query = "SELECT spip_documents.id_document FROM spip_documents LEFT JOIN spip_documents_articles ON spip_documents.id_document = spip_documents_articles.id_document WHERE spip_documents_articles.id_article = ".$id_article;
  }
  else {
    $query = "SELECT id_document FROM spip_documents_liens WHERE objet='article' AND id_objet = ".$id_article;
  }
  $rsc = mysql_query($query, $link);
  while ($row = mysql_fetch_object($rsc)) {
    $data = _spip2drupal_fetch('id_document', $row->id_document);
    if ($data === FALSE) {
      continue;
    }
    $src = $spip_path.'/'.$data->fichier;
    if (!file_copy($src)) {
      form_set_error('', t('«%file» does not exist. SPIP article id: %id_article.', array('%file' => $data->fichier, '%id_article'=> $id_article)));
      continue;
    }
    $filename = array_pop(explode('/', $data->fichier));
    $filemime = file_get_mimetype($src);
    $file = (object)array(
      'uid'       => $uid,
      'filename'  => $filename,
      'filepath'  => $files_path.'/'.$filename,
      'filemime'  => $filemime,
      'filesize'  => $data->taille,
      'status'    => FILE_STATUS_TEMPORARY,
      'timestamp' => $data->date,
    );
    drupal_write_record('files', $file);

    $file->new = TRUE;
    $file->list = TRUE;
    $file->description = $data->titre;
    $files[$file->fid] = $file;
  }

  return $files;
}

/**
 * Batch operation. Import SPIP comments.
 */
function _spip2drupal_import_comments(&$context) {
  $link = spip_db_connect();
  // if it is the first time, initialize the sandbox
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_forum) FROM spip_forum WHERE id_article != 0";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['comments'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $STEP = 20;
  
  // Cache mapping values for this batch iteration.
  $auteurs = array();
  $articles = array();
  $comments = array();
  $query = "SELECT id_forum FROM spip_forum WHERE id_article !=0 LIMIT $current,$STEP";
  $rs = mysql_query($query, $link);
  while ($row = mysql_fetch_object($rs)) {
    $data = _spip2drupal_fetch('id_forum', $row->id_forum);
    if ($data === FALSE) {
      $context['sandbox']['current']++;
      continue;
    }
    // related uid.
    if (!isset($auteurs[$data->id_auteur])) {
      $query = "SELECT uid FROM {spip_users} WHERE id_auteur = '".$data->id_auteur."' LIMIT 1";
      $auteurs[$data->id_auteur] = db_result(db_query($query));
    }
    $uid = $auteurs[$data->id_auteur];
    // related name.
    $name = db_result(db_query('SELECT name FROM {users} WHERE uid = %d LIMIT 1', array($uid)));
    // related nid.
    if (!isset($articles[$data->id_article])) {
      $query = "SELECT nid FROM {spip_articles} WHERE id_article = '".$data->id_article."' LIMIT 1";
      $articles[$data->id_article] = db_result(db_query($query));
    }
    $nid = $articles[$data->id_article];
    // related parent.
    if (!isset($comments[$data->id_forum])) {
      $query = "SELECT cid FROM {spip_comments} WHERE id_forum = '".$data->id_forum."' LIMIT 1";
      $comments[$data->id_forum] = db_result(db_query($query));
    }
    $pcid = $comments[$data->id_forum];
    
    $comment = array(
      'uid'      => $uid,
      'name'     => $name,
      'hostname' => $data->ip,
      'nid'      => $nid,
      'subject'  => $data->titre,
      'comment'  => $data->texte,
      'format'   => 1, // unfiltered HTML
      'pid'      => $pcid,
      'status'   => ($data->statut=='publie')?1:0,
    );
    // Save the comment.
    $cid = comment_save($comment);
    // sadly the comment_save function sets timestamp to time()...
    db_query("UPDATE {comments} SET timestamp=%d WHERE cid=%d", array($data->date_heure, $cid));
    $record = array('id_forum' => $data->id_forum, 'cid' => $cid);
    drupal_write_record('spip_comments', $record);
    
    // Update $context.
    $context['results']['comments']++;
    $context['message'] = "Importing comments: $current of $total.";
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    _spip2drupal_watchdog('Comment @id imported with cid @cid.', array('@id' => $row->id_forum, '@cid' => $cid), l('edit comment', 'comment/edit/'.$cid));
  }

  // update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Batch operation. Import SPIP breves as drupal breve nodes.
 */
function _spip2drupal_import_news(&$context) {
  $link = spip_db_connect();
  // if it is the first time, initialize the sandbox
  if (empty($context['sandbox'])) {
    $query = "SELECT COUNT(id_breve) FROM spip_breves";
    $total = mysql_result(mysql_query($query, $link), 0);
    $context['sandbox']['total'] = $total;
    $context['sandbox']['current'] = 0;
    $context['results']['news'] = 0;
    if ($total == 0) {
      $context['finished'] = 1;
      return;
    }
  }
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];

  $query = "SELECT * FROM spip_breves LIMIT $current,".SPIP2DRUPAL_STEP;
  $rsc = mysql_query($query, $link);
  while ($breve = mysql_fetch_array($rsc)) {
    $context['message'] = t('Importing breve @current of @total', array('@current' => $current, '@total' => $total));
    $node = (object)array(
      'type' => 'story',
      'title' => $breve['titre'],
      'created' => $breve['date_heure'],
      'changed' => $breve['maj'],
      'comment' => 1, // (1 = no further comments)
      'format' => 2, // Full HTML
      //'language' => 'en',
    );
    $lien = sprintf("<br/><a href='%s'>%s</a>", $breve['lien_titre'], $breve['lien_url']);
    $text = $breve['texte'].$lien;
    $node->teaser = $text;
    $node->body = $text;

    // calculate the article status
    switch ($breve['statut']) {
      // published
      case 'publie':
        $node->status = 1;
        break;
      // proposed to publish
      case 'prop': 
        $node->status = 0;
        break;        
      // refused
      case 'refuse':
        $node->status = 0;
        break;
    }
    // set the autor uid
    $node->uid = 0;

    // save the node and store the original id_article
    node_save($node);
    if ($node->nid) {
      db_query('INSERT INTO {spip_breves} (id_breve, nid) VALUES (%d, %d)', array($breve['id_breve'], $node->nid));
    }

    // set the section term
    $term = $sectionsmap[$breve['id_rubrique']];
    taxonomy_node_save($node, array($term));
    
    // update the sandbox
    $context['sandbox']['current']++;
    $current = $context['sandbox']['current'];
    _spip2drupal_watchdog('Breve @breve imported as node @nid.', array('@breve' => $breve['id_breve'], '@nid' => $node->nid), l('edit node', 'node/'.$node->nid.'/edit'));
    $context['results'][] = $message;
  }

  // update finished value 0..1
  $current = $context['sandbox']['current'];
  $total = $context['sandbox']['total'];
  $context['finished'] = $current / $total;
}

/**
 * Callback for batch finished.
 */
function _spip2drupal_import_done($success, $results, $operations) {
  if ($success) {    
    foreach ($results as $op => $result) {
      drupal_set_message(t('@num @op imported.', array('@op' => $op, '@num' => $result)));
    }
  }
  else {
    // An error occurred.
    // $operations contains the operations that remained unprocessed.
    $ops = reset($operations);
    $message = t('The error occurred in operation @op.', array('@op' => $ops[0]));
    if ($ops[1]) {
      $message .= ' '.t('The arguments to the operation are: @args.', array('@args' => implode(',', $ops[1])));
    }
    drupal_set_message($message, 'error');
  }
}


//// HELPER FUNCTIONS

/**
 * Log a watchdog message if configured so.
 */
function _spip2drupal_watchdog($message, $variables = array(), $link = NULL, $severity = WATCHDOG_NOTICE) {
  if (variable_get('spip2drupal_watchdog', FALSE)) {
    watchdog('spip2drupal', $message, $variables, $severity, $link);
  }
}

/**
 * Transform bodies of text with spip placeholders to full html.
 */
function _spip2drupal_fetch($arg, $value) {
  $url = variable_get('spip2drupal_spip_url', '')."?page=json&$arg=$value&var_mode=calcul";
  $result = drupal_http_request($url);
  if ($result->code >= 400) {
    form_set_error('', "Unable to fetch: $url");
    return FALSE;
  }
  $data = json_decode($result->data);
  if (!is_object($data)) {
    $dump = var_export($result->data, TRUE);
    form_set_error('', "Empty result for: $url<br/>Dump:<pre>$dump</pre>");
    return FALSE;
  }
  
  foreach ($data as $key => $value) {
    if (is_string($value)) {
      $data->$key = decode_entities($value);
    }
  }
  return $data;
}

/**
 * Returns the uid for $name or FALSE.
 */
function _spip2drupal_user_exist($name) {
  $rsc = db_query("SELECT uid FROM {users} u WHERE name = '%s'", array($name));
  if ($user = db_fetch_object($rsc)) {
    return $user->uid;
  }
  return FALSE;
}

